/* c:\djh\cc\slc\s\SLCCALL.C ***   L=013 --- 2003/06/21 18:19:13  (L07)
|
|		Copyright: Compute(Bridgend)Ltd (2003). 	     **
|
|
|
|
| L=013 2003/06/21 -djh- Support for SCO unix and GNU C++ on Linux.
| L=012 2000/07/17 -djh- Change "dup2" to "dup2rtn" to avoid AS/400 conflict with IBM's QSYS *SVRPGM QP0LLIB1.
| L=011 2000/03/31 -djh- Intro OS/2 Specific code.
| L=010 2000/03/30 -djh- Intro Windows Specific code.
| L=009 2000/03/28 -djh- Use -Kpic for "C/C++" on SUN, not -pic which is for "C++" only.
| L=008 2000/03/26 -djh- Renamed fr slccall.cpp to slccall.c to allow compile with "C" compiler.
| L=007 2000/03/22 -djh- EXTERNC added to internal funcs, (the CALL'ed rtns), to bypass
|			 compatibility probs with C++ name mangling changes in diff versions of SUN C++ compiler.
| L=006 2000/03/19 -djh- EXTERNC added to slccall() for callers without C++ compiler.
| L=005 1996/12/12 -djh- array bounds [17], not [], reqd for AIX.
| L=004 1996/03/20 -djh- called rtns must test for no parms.
| L=001 1996/03/14 -djh- started as slccall.cpp for C++ compiler.
*/

/*		    The CALL Statement for SELCOPY
|		    ------------------------------
| General
| -------
|   The slccall.c and .h source files are supplied as part of the licensed software, "SELCOPY", for
|   Unix and 32-bit Windows and OS2 platforms:
|		   WNT, OS2, SUN, DEC, AIX, HPX, SCO, LNX.
|
|   It is required for use in conjuction with use of the CALL statement within SELCOPY, but requires
|   tailoring by the user in order to identify and call the required user-named routine.
|
|   slccall should be compiled and linked separately at the user's own installation, using either a
|   "C" or "C++" compiler.
|
|
|
| PC/DOS and AS/400 platforms					     **
| ---------------------------
|   User-written functions for the CALL Statement for PCD and AS4 are not supported.
|   The slccall object code has already been linked into the selcopy.exe file, so no user-written
|   routines can be added.
|   The most you can do is to use the function, DUPSTR, which is supplied below as a sample.
*/





/*    SUN Sparc platform - Solaris			       ***   **
|     ----------------------------
|   The -Kpic (position independent code) option must be used for the
|   compilation, together with the -c (compile only) option.
|   e.g.
|	 cc  -c  -Kpic	 slccall.c
|
|
|   The object file, slccall.o, from the above compilation must then
|   be linked separately, using ld with the -G option to produce output
|   as a "Shared Object" (.so), where undefined symbols are allowed.
|   e.g.
|	 ld  -G   -z text   -o slccall.so   slccall.o
|
|   The above	  -z text  option will force a fatal error from ld, if any
|   relocations against non-writable, allocatable sections remain.
|
|   The slccall function could call another function that resides in
|   yet another .so file, and so on.
|
|
|   Sun's Sparc Solaris documentation refers to a file such as
|   slccall.so	as a Shared Dynamic Library.
|   It is in fact a file, (not a directory), but of course, it could
|   contain object code for several functions, hence the name library.
|
|   The .so (Shared Object) suffix is mandatory.
|
|
|   The main SELCOPY program has been linked with the option:
|	 -R /usr/selcopy
|			  which causes the runtime linker to search
|   in the directory /usr/selcopy for any shared object files it may
|   require, (i.e. slccall.so).
|   You may wish to set up a symbolic link so that any reference to
|   /usr/selcopy will be re-routed to the name of your choice.
|
*/






/*    DEC Alpha platform - Digital Unix 		       ***   **
|     ---------------------------------
|   The -shared option must be used for the compilation, together with
|   the -c	option (compile only),
|   and -o	option defining object destn file.
|    e.g.
|	  cxx	-c  -shared  -o ./olib/slccall.o     slccall.cpp
|
|
|
|   The object file, slccall.o, from the above compilation must then
|   be linked separately, using ld, as follows, to produce output
|   as a "Shared Object" (.so), where undefined symbols are allowed.
|   Thus slccall could call a func that resides in yet another .so file.
|    e.g.
|     ld -o /usr/selcopy/slccall.so -shared -no_archive -lc ./olib/slccall.o
|
|
|
|   The main SELCOPY program has been linked with the option:
|	 -rpath /usr/selcopy
|			  which causes the runtime linker to search
|   in the directory /usr/selcopy for any shared object files it may
|   require, (i.e. slccall.so).
|   You may wish to set up a symbolic link so that any reference to
|   /usr/selcopy will be re-routed to the name of your choice.
|
*/










/*    IBM RS/6000 platform - AIX			       ***   **
|     --------------------------
|   The -shared option must be used for the compilation, together with
|   the -c	option (compile only),
|   and -o	option defining object destn file.
|    e.g.
|	  cc	-c  -shared  -o ./olib/slccall.o     slccall.cpp
|
|
|
|   The object file, slccall.o, from the above compilation must then
|   be linked separately, using ld, as follows, to produce output
|   as a "Shared Object" (.so), where undefined symbols are allowed.
|   Thus slccall could call a func that resides in yet another .so file.
|    e.g.
|     ld -o /usr/selcopy/slccall.so -shared -no_archive -lc ./olib/slccall.o
|
|
|
|   The main SELCOPY program has been linked with the option:
|	 -rpath /usr/selcopy
|			  which causes the runtime linker to search
|   in the directory /usr/selcopy for any shared object files it may
|   require, (i.e. slccall.so).
|   You may wish to set up a symbolic link so that any reference to
|   /usr/selcopy will be re-routed to the name of your choice.
|
|
|		     --- End of SLCCALL documentation ---
*/












/*	       ___________________________________	   ***
|	      | 				  |
|	      | 	CALLED ROUTINES 	  |
|	      | 	   (Internal to slccall.) |
|	      |___________________________________|
*/

#define CALL_CPP   1

#include "slccall.h"


EXTERNC int  dupstr  (char *(*list)[17])     /* Sample Rtn.	     **/
{
int i;
int len;
char *src;				 /* Source data elem. */

 if (!*list[0])    return 0;		 /* Do nothing if no parms. */
 src = (*list)[0];			 /* Source data. */
 len = strlen(src);
 for (i=1; (*list)[i]!=NULL; i++)
    memcpy ((*list)[i], src, len );	 /* Duplicate a string. */
 return 247;
}


EXTERNC int  dup2rtn (char *(*list)[17])     /* Sample Rtn.	     **/
{
int i;
char *src;				 /* Source data elem. */

 if (!*list[0])    return 0;		 /* Do nothing if no parms. */
 src = (*list)[0];			 /* Source data. */
 for (i=1; (*list)[i]!=NULL; i++)
    memcpy ((*list)[i], src, 2	 );	 /* Duplicate 2 chars. */
 return 0;
}


EXTERNC int  calltest(char *(*list)[17])     /* Sample Rtn.	     **/
{
int i;
int src;				 /* Source data elem. */

 if (!*list[0])    return 0;		 /* Do nothing if no parms. */
 src = (*list)[0][0];			 /* Source char. */
 for (i=1; (*list)[i]!=NULL; i++)
    (*list)[i][0] = src;		 /* Duplicate single char. */
 return 0;
}





/*	       ___________________________________	   ***
|	      | 				  |
|	      | 	Windows Specific.	  |
|	      |___________________________________|
*/

#if defined(__NT__)   &&  !defined(__cplusplus)
  #include <windows.h>

  int APIENTRY	 LibMain( HANDLE hdll,	DWORD reason,  LPVOID reserved )
  {
   switch( reason )
    {
     case DLL_THREAD_ATTACH:
	 /* do thread initialization */
	 break;

     case DLL_THREAD_DETACH:
	 /* do thread cleanup */
	 break;

     case DLL_PROCESS_ATTACH:
	 /* do process initialization */
	 break;

     case DLL_PROCESS_DETACH:
	 /* do process cleanup */
	 break;
    }

   return( 1 );        /* indicate success */
		       /* returning 0 indicates initialization failure */
  }
#endif








/*	       ___________________________________	   ***
|	      | 				  |
|	      | 	OS/2	Specific.	  |
|	      |___________________________________|
*/

#if defined(__OS2V2__)	 &&  !defined(__cplusplus)

  unsigned LibMain( unsigned hmod,  unsigned termination )
  {
   if (termination)
    {
     ;	/* DLL is detaching from process */
    }
   else
    {
     ;	/* DLL is attaching to process */
    }

   return( 1 );        /* indicate success */
		       /* returning 0 indicates initialization failure */
  }
#endif








/*	       ___________________________________	   ***
|	      | 				  |
|	      | 	CONTROL ROUTINE 	  |
|	      |___________________________________|
*/

EXTERNC int CDECL   slccall (char *nam,  char *(*list)[17] )   /* Control Func. **/
{

/* The name EXTERNC is defined in slccall.h as:     extern "C"          for C++ only, else null.
|  The name  CDECL  is defined in slccall.h as:     __cdecl or _cdecl	for NT only,  else null.
|
|  "C" linkage is used to to call this C++ rtn, thus allowing the user to replace it
|  with a modified version suitable for compiling with the "C" compiler.
|
|	    nam   is a pointer to the name of the called rtn.
|	    list  is a pointer to an array of up to 16 pointers to
|				       char strings,  + a null ptr.
|
|
|	  e.g.	CALL DUPSTR   DATE-2   1  22
|
|		Results in a call to this function, slccall, with
|
|		       nam     --> "DUPSTR"  (Null terminated.)
|		       list[0] --> SELCOPY's internal Date Table.
|				     e.g. "1996/03/13 23:25 ... etc ..."
|		       list[1] --> Position 1  of the SELCOPY work area.
|		       list[2] --> Position 22 of the SELCOPY work area.
|		       list[3] --> Null.
|
|		CALL DUPSTR  "xxxx"  1  22 101 201  * Would use "xxxx".
*/



int   rc;	  /*** Return Code ***/

 rc = -1;      /* Negative return value to indicate rtn not found. */
 if	 (strcmp(nam, "DUPSTR"  ) == 0)     rc = dupstr(list);

 else if (strcmp(nam, "BR14"    ) == 0                       /* Synonym to fit m/f tests. */
       || strcmp(nam, "DUP2"    ) == 0)     rc = dup2rtn(list);

 else if (strcmp(nam, "CALLTEST") == 0)     rc = calltest(list);

 return rc;

}	     /*      --- End of slccall() ---	   */
